// RSSPECAN - Read Scan Example.cpp : implementation file
//

#include "stdafx.h"
#include "RSSPECAN - Read Scan Example.h"
#include "RSSPECAN - Read Scan ExampleDlg.h"
#include <fstream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define QUEUE_SIZE                  10000
#define TRACE_POINTS_LIMIT  QUEUE_SIZE
#define ARRAY_SIZE          TRACE_POINTS_LIMIT         /* for rsspecan_ReadYTrace() varable: amplitude */
#define STRING_LENGTH       512
#define EMI_RECEIVER "ESL"
#define WINDOW_1            1
#define WINDOW_2            2
#define TRACE_1             1 
#define TRACE_2             2
#define SCAN_RANGE_1        1

#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }


// CSPECANReadExampleDlg dialog




CSPECANReadExampleDlg::CSPECANReadExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSPECANReadExampleDlg::IDD, pParent)
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_StartFrq(100.00E+3)
	, m_StopFrq(1.00E+9)
	, m_FrqStep(100.00E+3)
	, m_trace(0)
	, m_DisplayOn(FALSE)
	, m_Path(_T("c:\\trace.csv"))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSPECANReadExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Text(pDX, IDC_STARTFRQ, m_StartFrq);
	DDX_Text(pDX, IDC_STOPFRQ, m_StopFrq);
	DDX_Text(pDX, IDC_FRQSTEP, m_FrqStep);
	DDX_Text(pDX, IDC_PATH, m_Path);
	DDX_CBIndex(pDX, IDC_TRACE, m_trace);
	DDX_Check(pDX, IDC_DISPLAY, m_DisplayOn);
}

BEGIN_MESSAGE_MAP(CSPECANReadExampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_GENERATE, &CSPECANReadExampleDlg::OnBnClickedGenerate)
	ON_BN_CLICKED(IDC_BROWSE, &CSPECANReadExampleDlg::OnBnClickedBrowse)
END_MESSAGE_MAP()


// CSPECANReadExampleDlg message handlers

BOOL CSPECANReadExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSPECANReadExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSPECANReadExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSPECANReadExampleDlg::OnBnClickedGenerate()
{
		
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	ofstream out_file;
	double meas_results[201]= {0.0};
	ViChar      instr_desc [STRING_LENGTH] = "";
    ViChar      instr_modl [STRING_LENGTH] = "";


    ViStatus temp_status  = VI_SUCCESS;
    ViInt32  actual_count = 0;
    ViInt32	 status_reg;
	ViInt32	 firstblock = 1;
    
    ViReal64 trace[6][ARRAY_SIZE];
    ViInt32  traceStatus=0,noofPoints=0,pointsToPrint=0;
    ViChar   statusData[ARRAY_SIZE];
	ViReal64	*p2trace = trace[0];
/************************************ TODO ****************************************/
    
	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) m_ResourceString), m_IDQuery, m_Reset, &m_InstrSession));
                
	/* check for EMI test receiver */
	
	CHECKERR( rsspecan_GetAttributeViString (m_InstrSession, "", RS_ATTR_INSTRUMENT_MODEL, STRING_LENGTH, instr_modl));
	if(NULL == strstr(EMI_RECEIVER, instr_modl))
	{
		/*  */
		// "Instrument does not support EMI scan measurements"
		/* free resource */
		cleanup(VI_TRUE);
	} 
	else 
	{
		/* switch to receiver mode */
		CHECKERR (rsspecan_ReceiverMode (m_InstrSession));
                
		/* switch device display on/off */
		CHECKERR( rsspecan_ConfigureDisplayUpdate (m_InstrSession, m_DisplayOn)); 
                
		/* set one scan at 0.1 milliseconds */
		CHECKERR (rsspecan_ConfigureScanTableMeasTime (m_InstrSession, 1, 0.0001));
                
		/* set scan step mode */
		CHECKERR (rsspecan_ConfigureReceiverStepMode (m_InstrSession, RSSPECAN_VAL_SWEEP_SPAC_LIN));
                    
		/* switch to single sweep */
		CHECKERR (rsspecan_ConfigureAcquisition (m_InstrSession, WINDOW_2, VI_FALSE, 1));
                
		/* for security reasons */
		CHECKERR (rsspecan_ConfigureReceiverTracePoints (m_InstrSession, ARRAY_SIZE)); 
                
		/* Set start and stop frequency and the stepsize */
		CHECKERR (rsspecan_ConfigureScanTableStartStop(m_InstrSession, 1, m_StartFrq, m_StopFrq, m_FrqStep));
				
		/* Send trace datas before trace is finished, too */
		CHECKERR (rsspecan_ConfigureReceiverTraceFeedControl (m_InstrSession, RSSPECAN_VAL_TRAC_FEED_ALWAYS));

		rsspecan_ConfigureFinalReceiverDetector (m_InstrSession, 1, 1, RSSPECAN_VAL_DETECTOR_TYPE_MIN_PEAK);
	
		/* Select m_trace */
		if( m_trace == 0) // Average
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_TRUE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE));
		}
		else if(m_trace == 1)  // Max Peak
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_FALSE, VI_TRUE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE));
		}
		else if(m_trace == 2)  // Min Peak
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_FALSE, VI_FALSE, VI_TRUE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE));
		}
		else if(m_trace == 3)  // RMS
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_FALSE, VI_FALSE, VI_FALSE, VI_TRUE, VI_FALSE, VI_FALSE, VI_FALSE));
		}
		else if(m_trace == 4)  // QPeak
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_TRUE, VI_FALSE, VI_FALSE));
		}
		else if(m_trace == 5)  // CAverage
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_TRUE, VI_FALSE));
		}
		else if(m_trace == 6)  // CRMS
		{
			CHECKERR (rsspecan_ConfigureReceiverDetector (m_InstrSession, 1, 1, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_FALSE, VI_TRUE));
		}
		
		
		/*  */
		CHECKERR (rsspecan_RunReceiverMeasurement(m_InstrSession));
		
		while (!(traceStatus & 0x1000))
		{
			//Read status register
			rsspecan_getStatusRegister (m_InstrSession, 1, &status_reg);
			
			if(status_reg & 512)
			{
    			//Read Trace
				temp_status = rsspecan_ReadScanMeasurement (m_InstrSession, ARRAY_SIZE, &traceStatus, &noofPoints, statusData, 
					  p2trace+pointsToPrint, trace[1], trace[2], trace[3], trace[4], trace[5]);
		
				if( temp_status != VI_SUCCESS )
				{
					/* check error (specan driver) and prompt it */
					CHECKERR(temp_status);
				}
				pointsToPrint += noofPoints;
			}
			else
				Sleep (50);
		}
		
		out_file.open( m_Path);
		for(int i=0; i < pointsToPrint; i++)
		{
			out_file << trace[0][i] << ";";
		}
		out_file.close();
		

	}
	CHECKERR (rsspecan_close (m_InstrSession));
	
	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void CSPECANReadExampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}
void CSPECANReadExampleDlg::OnBnClickedBrowse()
{
	CFileDialog fileDlg( FALSE);

	if ( fileDlg.DoModal() == IDOK)
	{
		m_Path = fileDlg.GetPathName();
		UpdateData(FALSE);
	}
}



