// rsspecan_IQ_measurement_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsspecan_IQ_measurement_example.h"
#include "rsspecan_IQ_measurement_exampleDlg.h"
#include <fstream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WINDOW        1
#define NUMBER_OF_VALUES 4096


#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsspecan_IQ_measurement_exampleDlg dialog




Crsspecan_IQ_measurement_exampleDlg::Crsspecan_IQ_measurement_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsspecan_IQ_measurement_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(FALSE)
	, m_CenterFreq(4000000000)
	, m_RefLevel(-20)
	, m_Path(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsspecan_IQ_measurement_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_CENTERFREQ, m_CenterFreq);
	DDX_Text(pDX, IDC_REFLEVEL, m_RefLevel);
	DDX_Text(pDX, IDC_RESULT, m_Path);
}

BEGIN_MESSAGE_MAP(Crsspecan_IQ_measurement_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_OPEN, &Crsspecan_IQ_measurement_exampleDlg::OnBnClickedOpen)
	ON_BN_CLICKED(IDC_START, &Crsspecan_IQ_measurement_exampleDlg::OnBnClickedStart)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// Crsspecan_IQ_measurement_exampleDlg message handlers

BOOL Crsspecan_IQ_measurement_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsspecan_IQ_measurement_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsspecan_IQ_measurement_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsspecan_IQ_measurement_exampleDlg::OnBnClickedOpen()
{
	CFileDialog fileDlg( FALSE, _T("txt"), _T("*.txt"), OFN_OVERWRITEPROMPT, _T("Text File (*.txt)|*.txt|All Files (*.*)|*.*||"));

	if ( fileDlg.DoModal() == IDOK)
	{
		UpdateData();
		m_Path = fileDlg.GetPathName();
		UpdateData(false);
	}
}

void Crsspecan_IQ_measurement_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	ofstream	out_file;

	ViInt32 timeout = 15000;    /* default value */
    ViInt32 returnedValues;
    ViReal64 resultI[NUMBER_OF_VALUES];
    ViReal64 resultQ[NUMBER_OF_VALUES];

	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	m_ResourceString.UnlockBuffer();

	/* switch device display on/off */
	CHECKERR( rsspecan_ConfigureDisplayUpdate(m_InstrSession,m_Display));

	/* configure the center frequency */
    CHECKERR( rsspecan_ConfigureFrequencyCenter(m_InstrSession, WINDOW, m_CenterFreq));

    /* configure the reference level */
	CHECKERR( rsspecan_ConfigureReferenceLevel(m_InstrSession, WINDOW, m_RefLevel));

    /* select trace IQ measurement */
    CHECKERR( rsspecan_ConfigureTraceIQDataAcquisition(m_InstrSession, WINDOW, VI_TRUE));

    /* configure the trace IQ */
    CHECKERR( rsspecan_TraceIQSet(m_InstrSession, WINDOW, 32.0e6, 0, 0, 10.0e6, 0, NUMBER_OF_VALUES));

    if (m_Path == "")
    {
        CFileDialog fileDlg( FALSE, _T("txt"), _T("*.txt"), OFN_OVERWRITEPROMPT, _T("Text File (*.txt)|*.txt|All Files (*.*)|*.*||"));

		if ( fileDlg.DoModal() == IDOK)
		{
			UpdateData();
			m_Path = fileDlg.GetPathName();
			UpdateData(false);
		}
    }

    /* This function will start a measurement and read I/Q trace data results. */
    CHECKERR( rsspecan_ReadTraceIQData(m_InstrSession, WINDOW, timeout, NUMBER_OF_VALUES, &returnedValues, resultI, resultQ));

    /* save data to file */
	out_file.open(m_Path);
	out_file << "Real part\tImaginary part\n";
	for(int i=0;i<returnedValues;i++){
		out_file << resultI[i] << "\t" << resultQ[i] << "\n";
	}

    /* This function will start second measurement and read I/Q trace data results. */
    CHECKERR( rsspecan_ReadTraceIQData(m_InstrSession, WINDOW, timeout, NUMBER_OF_VALUES, &returnedValues, resultI, resultQ));

    /* save data to file */
    out_file << "Real part\tImaginary part\n";
	for(int i=0;i<returnedValues;i++){
		out_file << resultI[i] << "\t" << resultQ[i] << "\n";
	}
	out_file.close();

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	/* close session */
	CHECKERR (rsspecan_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsspecan_IQ_measurement_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}
