// rsspecan_marker_functions_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsspecan_marker_functions_example.h"
#include "rsspecan_marker_functions_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define WINDOW        1


#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }


// Crsspecan_marker_functions_exampleDlg dialog




Crsspecan_marker_functions_exampleDlg::Crsspecan_marker_functions_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsspecan_marker_functions_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Input(0)
	, m_GenAmplitude(-30)
	, m_PeakType(0)
	, m_Excursion(0)
	, m_MarkerPos(_T(""))
	, m_MarkerAmpl(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsspecan_marker_functions_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_CBIndex(pDX, IDC_INPUT, m_Input);
	DDX_Text(pDX, IDC_GENAMPLITUDE, m_GenAmplitude);
	DDV_MinMaxDouble(pDX, m_GenAmplitude, -30, 0);
	DDX_CBIndex(pDX, IDC_PEAK_TYPE, m_PeakType);
	DDX_Text(pDX, IDC_PEAKEXCURSION, m_Excursion);
	DDV_MinMaxDouble(pDX, m_Excursion, 0, 80);
	DDX_Text(pDX, IDC_MARKERPOS, m_MarkerPos);
	DDX_Text(pDX, IDC_MARKERAMP, m_MarkerAmpl);
}

BEGIN_MESSAGE_MAP(Crsspecan_marker_functions_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsspecan_marker_functions_exampleDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &Crsspecan_marker_functions_exampleDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_SEARCH, &Crsspecan_marker_functions_exampleDlg::OnBnClickedSearch)
END_MESSAGE_MAP()


// Crsspecan_marker_functions_exampleDlg message handlers

BOOL Crsspecan_marker_functions_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	EnableButtons(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsspecan_marker_functions_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsspecan_marker_functions_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsspecan_marker_functions_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	ViInt32 timeout = 15000;    /* default value */
	double markerPosition, markerAmplitude;
	CString str;
	ViChar instrModel[512];

	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	m_ResourceString.UnlockBuffer();

	/* Set instrument to single sweep mode - continous mode is done
     * programmatically because this is the only way how to
     * synchronize measurement using *OPC
     */

    CHECKERR (rsspecan_ConfigureSignalStatisticSweep(m_InstrSession, VI_FALSE));

	CHECKERR (rsspecan_GetAttributeViString(m_InstrSession, "", RS_ATTR_INSTRUMENT_MODEL, 512, instrModel));

	if (strcmp (instrModel, "FSC") != 0 && strcmp (instrModel, "FSH") != 0)
	{
		/* select input */
		CHECKERR (rsspecan_ServiceConfigureInput(m_InstrSession, WINDOW, m_Input, m_GenAmplitude));
	}

    /* Enable marker */
    CHECKERR (rsspecan_SetAttributeViBoolean(m_InstrSession, "Win0,M1", RSSPECAN_ATTR_MARKER_ENABLED, true));

    /* perform sweep */
    CHECKERR (rsspecan_Initiate(m_InstrSession, WINDOW, timeout));

    /* specifies the type of marker search and performs the search */
    CHECKERR (rsspecan_MarkerSearch(m_InstrSession, WINDOW,1,m_PeakType + 1));

    /* returns the position of the selected marker */
    CHECKERR (rsspecan_QueryMarker(m_InstrSession, WINDOW, 1, &markerPosition, &markerAmplitude));

    /* write marker position to front panel */
	str.Format(_T("%.f"),markerPosition);
	m_MarkerPos = str;
	str.Format(_T("%.2f"),markerAmplitude);
	m_MarkerAmpl = str;

	UpdateData(false);

	EnableButtons(true);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
}

void Crsspecan_marker_functions_exampleDlg::OnBnClickedStop()
{
	EnableButtons(false);
	m_PeakType = 0;
	UpdateData(false);
	CHECKERR (rsspecan_close (m_InstrSession));
}

void Crsspecan_marker_functions_exampleDlg::OnBnClickedSearch()
{
	UpdateData();
	double markerPosition, markerAmplitude;
	CString str;

	/* set peak excursion value */
	CHECKERR (rsspecan_ConfigureMarkerSearchPeakExcursion(m_InstrSession, WINDOW, m_Excursion));

    /* specifies the type of marker search and performs the search */
    CHECKERR (rsspecan_MarkerSearch(m_InstrSession, WINDOW, 1, m_PeakType + 1));

    /* returns the position of the selected marker */
    CHECKERR (rsspecan_QueryMarker(m_InstrSession, WINDOW, 1, &markerPosition, &markerAmplitude));

    /* write marker position to front panel */
	str.Format(_T("%.f"),markerPosition);
	m_MarkerPos = str;
	str.Format(_T("%.2f"),markerAmplitude);
	m_MarkerAmpl = str;
	
	UpdateData(false);
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsspecan_marker_functions_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}

/*===========================================================================*/
/* Function: Enable Buttons
/* Purpose:  Enables/disables the front panel controls.
/*===========================================================================*/
void Crsspecan_marker_functions_exampleDlg::EnableButtons(bool enable)
{
	CWnd* pdlg_item;
	
	pdlg_item = this->GetDlgItem(IDC_PEAK_TYPE);
	pdlg_item->EnableWindow(enable);
	pdlg_item = this->GetDlgItem(IDC_PEAK_EXCURSION);
	pdlg_item->EnableWindow(enable);
	pdlg_item = this->GetDlgItem(IDC_SEARCH);
	pdlg_item->EnableWindow(enable);
	pdlg_item = this->GetDlgItem(IDC_STOP);
	pdlg_item->EnableWindow(enable);
	pdlg_item = this->GetDlgItem(IDC_START);
	pdlg_item->EnableWindow(!enable);
	
}
