// rsspecan_peak_list_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsspecan_peak_list_example.h"
#include "rsspecan_peak_list_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WINDOW        1


#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsspecan_peak_list_exampleDlg dialog




Crsspecan_peak_list_exampleDlg::Crsspecan_peak_list_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsspecan_peak_list_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("TCPIP::10.112.0.85::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(FALSE)
	, m_CenterFreq(1000000000)
	, m_FreqSpan(100000000)
	, m_SweepTime(0.01)
	, m_Excursion(3)
	, m_ListValues(5)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsspecan_peak_list_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DATALIST, m_DataList);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_CENTERFREQ, m_CenterFreq);
	DDX_Text(pDX, IDC_FREQSPAN, m_FreqSpan);
	DDX_Text(pDX, IDC_SWEEPTIME, m_SweepTime);
	DDX_Text(pDX, IDC_EXCURSION, m_Excursion);
	DDV_MinMaxDouble(pDX, m_Excursion, 0, 80);
	DDX_Text(pDX, IDC_CENTERFREQ2, m_ListValues);
	DDV_MinMaxInt(pDX, m_ListValues, 1, 50);
}

BEGIN_MESSAGE_MAP(Crsspecan_peak_list_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsspecan_peak_list_exampleDlg::OnBnClickedStart)
	ON_EN_CHANGE(IDC_LIST_VALUES, &Crsspecan_peak_list_exampleDlg::OnEnChangeListValues)
END_MESSAGE_MAP()


// Crsspecan_peak_list_exampleDlg message handlers

BOOL Crsspecan_peak_list_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Init Table Header
	m_DataList.InsertColumn (0, _T("Frequency [Hz]"),LVCFMT_LEFT,130);
	m_DataList.InsertColumn (1, _T("Aplitude [dBm]"),LVCFMT_LEFT,110);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsspecan_peak_list_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsspecan_peak_list_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsspecan_peak_list_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	CString		str;

	ViInt32 timeout = 15000;    /* default value */
    ViReal64 results[50];

	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	m_ResourceString.UnlockBuffer();

	/* switch device display on/off */
	CHECKERR( rsspecan_ConfigureDisplayUpdate(m_InstrSession,m_Display));

	/* Set instrument to single sweep mode - continous mode is done
     * programmatically because this is the only way how to
     * synchronize measurement using *OPC
     */
    CHECKERR (rsspecan_ConfigureSignalStatisticSweep(m_InstrSession, VI_FALSE));

	/* configure specan device: center frequency and span */
	CHECKERR (rsspecan_ConfigureFrequencyCenterSpan (m_InstrSession, WINDOW, m_CenterFreq, m_FreqSpan));

	/* configure sweep time */
    CHECKERR (rsspecan_ConfigureSweepCoupling(m_InstrSession, WINDOW, 2, m_SweepTime));

    /* configure peak excursion */
    CHECKERR (rsspecan_ConfigureMarkerSearchPeakExcursion(m_InstrSession, WINDOW, m_Excursion));

    timeout = (int)(m_SweepTime * 1000) + 1000;

    /* do a sweep */
    CHECKERR (rsspecan_Initiate(m_InstrSession, WINDOW, timeout));

    /* configure marker peak list */
    //CHECKERR (rsspecan_ConfigureMarkerPeakList(m_InstrSession, WINDOW, 1, m_ListValues, 0));
	CHECKERR(rsspecan_ConfigureMarkerPeakList(m_InstrSession, WINDOW, 1, m_ListValues, RSSPECAN_VAL_MARKER_SORT_X, 50, VI_TRUE));
	//CHECKERR(rsspecan_SetAttributeViInt32(m_InstrSession, "Win0,M1", RSSPECAN_ATTR_MARKER_PEAK_LIST_COUNT, m_ListValues));
	//CHECKERR(rsspecan_SetAttributeViInt32(m_InstrSession, "Win0,M1", RSSPECAN_ATTR_MARKER_PEAK_LIST_SORT, RSSPECAN_VAL_MARKER_SORT_X));
	

    /* read marker peak list */
    CHECKERR (rsspecan_QueryMarkerPeakList(m_InstrSession, WINDOW, 1, m_ListValues, 0, results));
	


	m_DataList.DeleteAllItems();

    /* write peak list to table */
    for (int i = 0; i < m_ListValues; i++)
    {
		m_DataList.InsertItem(i,_T(""));
		str.Format(_T("%.f"),results[i]);
        m_DataList.SetItemText(i, 0,str );
    }


    /* read marker peak list */
    CHECKERR (rsspecan_QueryMarkerPeakList(m_InstrSession, WINDOW, 1, m_ListValues, 1, results));

    /* write peak list to table */
    for (int i = 0; i < m_ListValues; i++)
    {
		str.Format(_T("%.2f"),results[i]);
        m_DataList.SetItemText(i, 1, str);
    }

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	/* close session */
	CHECKERR (rsspecan_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsspecan_peak_list_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}

void Crsspecan_peak_list_exampleDlg::OnEnChangeListValues()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}
